## Copyright (C) 2007,2008,2009 Bertrand Roessli <bertrand.roessli@psi.ch>
##
##
## MuFit is free software; you can redistribute it and/or
## modify it under the terms of the GNU General Public
## License as published by the Free Software Foundation;
## either version 2, or (at your option) any later version.
##
## Mufit is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied
## warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
## PURPOSE.  See the GNU General Public License for more
## details.
##
## You should have received a copy of the GNU General Public
## License along with Octave; see the file COPYING.  If not,
## write to the Free Software Foundation, Inc., 51 Franklin Street,
## Fifth Floor, Boston, MA 02110-1301, USA.
##
##
## NOT USED ANYMORE SINCE MUFIT_V3.4 (08.03.2009)

function crys_int_calc(genpar,singlecrys,domains_cell,spins_cart_cell,propvec_cell_rlu,flag_k0)
%---- calculates singlecrystal intensities overaged over domains

lambda=genpar.lambda;
zach=genpar.zach;

I_hkl_av=zeros(1,singlecrys{2});
lor=zeros(1,singlecrys{2});

for kk=3:singlecrys{2}+2
	Q=[[singlecrys{kk}].hhkl_AA];
        d_sp=2*pi/norm(Q);
        th_angle=asin(lambda./2./d_sp);
        lor(kk-2)=1./sin(2.*th_angle);
 
	I_singcrys_dom=0;
       	for ii=1:domains_cell{1}
		if (domains_cell{ii+1}.pop > 0.01)
			%rotation matrices for domains are given in a cartesian coordinates in input file
        		hkl_dom(1:3)=domains_cell{ii+1}.rot*(singlecrys{kk}.hhkl_AA)';
	        	%Q-vector
        		H=hkl_dom(1);
        		K=hkl_dom(2);
        		L=hkl_dom(3);
        		%----- Q vector in cartesian coordinates (1/A)
                	Q=[H;K;L]';
			%mag. inter. vec., |F|^2 and magnetic interaction vector in cartesian coordinates
			[mag_inter_vec,fsqr,mag_vec_cart]=magfac(spins_cart_cell,Q,singlecrys{kk}.hhkl_rlu,propvec_cell_rlu,flag_k0,'T');
			%calculate extinction	
			[extinc_hkl]=extinc(fsqr,genpar.lambda,genpar.zach,Q);
			if (singlecrys{1}.intfsqr== 0)
        			I_singcrys_dom=I_singcrys_dom.+domains_cell{ii+1}.pop.*fsqr.*lor(kk-2).*extinc_hkl;
			else
        			I_singcrys_dom=I_singcrys_dom.+domains_cell{ii+1}.pop.*fsqr.*extinc_hkl;
			endif
		endif
        endfor
	I_hkl_av(kk-2)=sum(I_singcrys_dom);
endfor

fprintf(stdout,'H    K    L    Int       Lorenz factor\n');
for k=1:singlecrys{2}
	fprintf(stdout,'%+f %+f %+f      %f   %f  \n', [singlecrys{k+2}.hhkl_rlu],I_hkl_av(k),lor(k));
endfor

endfunction
