## Copyright (C) 2007,2008,2009 Bertrand Roessli <bertrand.roessli@psi.ch>
##
##
## MuFit is free software; you can redistribute it and/or
## modify it under the terms of the GNU General Public
## License as published by the Free Software Foundation;
## either version 2, or (at your option) any later version.
##
## Mufit is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied
## warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
## PURPOSE.  See the GNU General Public License for more
## details.
##
## You should have received a copy of the GNU General Public
## License along with Octave; see the file COPYING.  If not,
## write to the Free Software Foundation, Inc., 51 Franklin Street,
## Fifth Floor, Boston, MA 02110-1301, USA.
##
## usage: mufit
##

## -*- texinfo -*-
## @deftypefn{Function File}  dfdp (@var{f},@var{p},@var{dp},@var{func},@var{varargin})
## @deftypefnx{Function File} {[@var{prt},@var{param}]} = dfdp (@var{f},@var{p},@var{dp},@var{func},@var{varargin})
## Calculate numerical Jacobian for use in leasqr (Leveberg-Marquard) 
## @*Use forward difference
## @*The step was taken from __bfgsmin.cc 
## @*Return the Jacobian and the parameter list



function [prt, param]=dfdp(f,p,dp,func,varargin)

m=rows(varargin{1});
n=length(p);     
prt=zeros(m,n);
step=exp(log(eps)/3); %---- from __bfgsmin.cc
ps=p; %----save initial parameters
for j=1:length(p)
      if dp(j)~=0
        p(j)=ps(j) + step;
        [f1, param]=feval(func,p,varargin{:});
        f1=f1(:);
        prt(:,j)=(f1-f)./step;
      endif
      p(j)=ps(j);     %---- set initial parameters into p
endfor
endfunction
