function nuclearintensites()


%---- read file
[genpar,as,bs,cs,aa,bb,cc,ion_nuc_cell,spgsym_nuc_cell,spgtrans_nuc_cell,twins,singlecrys,...
           parameters,dparameters,...
           nfit_type,simplexnuc_options,lmfitnuc_options,nsim_ann_par,...
           draw_nuc_opt]=readnuc;
lambda=genpar.lambda;

%--- hkl-list
nr_hkl=singlecrys{2}+2;
hkl_crys_AA=[[singlecrys{1,3:nr_hkl}].hhkl_AA];

hkl_crys_AA=reshape(hkl_crys_AA,3,columns(hkl_crys_AA)/3);
%--- structure factors (without extinction)
[nucstrucfac]=feval("nucfac",as,bs,cs,aa,bb,cc,ion_nuc_cell,spgsym_nuc_cell,spgtrans_nuc_cell,hkl_crys_AA');
%add extinction correction
if (genpar.zach ~= 0)
        x=real(nucstrucfac.*conj(nucstrucfac));  
        zachpar=genpar.zach;
        lambda=genpar.lambda;
        fhandle=@(x) extinc(x,lambda,zachpar,hkl_crys_AA');
        [ys]=fhandle(x);
else
        ys=ones(size(nucstrucfac));
endif
nucstrucfac=ys.*nucstrucfac;
%----
Q=hkl_crys_AA;
d_sp=2.*pi./dot(Q,Q).^0.5;  
th_angle=asin(lambda./2./d_sp);
lorcorr=1./sin(2.*th_angle);

intensity=lorcorr.*nucstrucfac.*conj(nucstrucfac);
hkl_crys_rlu=[[singlecrys{1,3:nr_hkl}].hhkl_rlu];
hkl_crys_rlu=reshape(hkl_crys_rlu,3,columns(hkl_crys_rlu)/3);
hkl=hkl_crys_rlu';
for i=1:size(nucstrucfac)(2)
    fprintf(stdout,"%+i  %+i  %+i   %+f\n",...
                    hkl(i,1),hkl(i,2),hkl(i,3),real(intensity(i)))
endfor

endfunction
