## Copyright (C) 2012 Bertrand Roessli <bertrand.roessli@psi.ch>          
##
##
## MuFit is free software; you can redistribute it and/or
## modify it under the terms of the GNU General Public
## License as published by the Free Software Foundation;
## either version 2, or (at your option) any later version.
##
## Mufit is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied
## warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
## PURPOSE.  See the GNU General Public License for more
## details.
##
## You should have received a copy of the GNU General Public
## License along with Octave; see the file COPYING.  If not,
## write to the Free Software Foundation, Inc., 51 Franklin Street,
## Fifth Floor, Boston, MA 02110-1301, USA.
##

function [G,Gstar]=metric(a,b,c,aa,bb,cc)
%
% Calculate metric tensor G and G*
% Corresponds to matrices R_01 and R_10 
% in crystallographic course 

%---- covariant metric tensor
G = [a^2 a*b*cosd(cc) a*c*cosd(bb); ...
     a*b*cosd(cc) b^2 b*c*cosd(aa); ...
     a*c*cosd(bb) b*c*cosd(aa)  c^2];

%---- contravariant metric tensor
Gstar= G^-1;

endfunction
